@ECHO OFF
IF NOT EXIST "Files 2 Zip\*" MD "Files 2 Zip"
:BEGIN
CLS
ECHO ZipOCD v.1.0 Rev. 3 by Argon
ECHO ------
ECHO.
SET KILL=
FOR %%P IN (7z.exe kzip.exe DeflOpt.exe zipmix.exe) DO (
	IF NOT EXIST %%P (
		ECHO File not found! - %%P
		SET KILL=1
	)
)
:KILL
IF NOT {%KILL%} == {} (
	ECHO.
	ECHO Error:
	IF {%KILL%} == {1} (
		ECHO One or more programs are missing. Please make sure they are in the same
		ECHO directory as zipocd.bat and run as Administrator if using Windows Vista.
	)
	IF {%KILL%} == {3} ECHO Unexpected error, try again.
	GOTO END
)
IF NOT {%1} == {} GOTO CMDLINE
IF {%FOLDERZIP%} == {} GOTO ZIPFOLDER
IF {%FINALZIP%} == {} GOTO ZIPNAME
:ZIPFOLDER
ECHO Enter the folder or file path for the files to be compressed. If left blank,
ECHO files from the "Files 2 Zip" subfolder will be zipped. Paths with spaces need
ECHO to have quotes around them; DOS wildcards or file names must be used for
ECHO files to be zipped.
ECHO.
ECHO ex. Dir: C:\Files\*
ECHO will compress all files and subfolders in C:\Files
ECHO.
SET /P FOLDERZIP=Dir: 
IF {%FOLDERZIP%} == {} SET FOLDERZIP=".\Files 2 Zip\*"
GOTO BEGIN
:ZIPNAME
ECHO Enter the name for the final zip file, include the .zip extension. Names with
ECHO spaces need to have quotes around them.
ECHO.
ECHO ex. "Zip Name.zip"
IF {%KILL%} == {2} (
	ECHO.
	ECHO Error: You must specify a file name.
)
ECHO.
SET /P FINALZIP=Zip: 
IF {%FINALZIP%} == {} (
	SET KILL=2
	GOTO ZIPNAME
)
GOTO START
:CMDLINE
FOR %%H IN (-? /? -help /help) DO (
	IF {%1} == {%%H} (
		ECHO Useage:
		ECHO zipocd [Folder or files] [Zip file]
		ECHO.
		ECHO Names with spaces need quotes around them.
		ECHO ex. zipocd C:\Files\* "Finished Zip.zip"
		ECHO ex. zipocd "C:\File Copy\*.txt" D:\Done.zip
		GOTO END
	)
)
SET FOLDERZIP=%1
IF {%2} == {} GOTO ZIPNAME
SET FINALZIP=%2
:START
7z a -tzip -mx=9 -mfb=258 -mpass=15 -r TEMP7z.zip %FOLDERZIP%
DeflOpt /b /f TEMP7z.zip
REN TEMP7z.zip TEMPt1z.zip
FOR %%B IN (0 32 64 96 128 160 192 224 256 288 320 352 384 416 448 480 512 544 576 608 640 672 704 736 768 800 832 864 896 928 960 992 1024) DO (
	kzip /b%%B /r TEMPkz-%%B.zip %FOLDERZIP%
	DeflOpt /b /f TEMPkz-%%B.zip
	zipmix TEMPt1z.zip TEMPkz-%%B.zip TEMPt2z.zip
	IF NOT EXIST TEMPt2z.zip (
		SET KILL=3
		GOTO KILL
	)
	DEL TEMPt1z.zip
	DEL TEMPkz-%%B.zip
	REN TEMPt2z.zip TEMPt1z.zip
)
:END
IF EXIST TEMPt1z.zip REN TEMPt1z.zip %FINALZIP%
ECHO.
ECHO ---
ECHO ZipOCD Finished.
ECHO.
PAUSE
SET KILL=
SET FOLDERZIP=
SET FINALZIP=
@ECHO ON